/* PLAN - program znajdowania trasy polaczen miedzy miastami */
%%% Przeszukiwanie wgłąb z nawrotami
:- dynamic(p/1).
:- dynamic(q/2).

d(s,g).
d(s,n1).
d(s,n2).
d(n1,n2).
d(n1,n4).
d(n1,n3).
d(n2,n3).
d(n3,n4).
d(n3,n5).
d(n4,n5).
d(n4,n6).
d(n5,n6).
d(n6,g).

nodes([s,n1,n2,n3,n4,n5,n6]).


%%% symmetric closure of d/2 
     connect(X,Y):- d(X,Y).
     connect(X,Y):- d(Y,X).
          
%%% transitive clouser of connect/2
     route(Goal,Goal,Path,Path):- !.
     route(Node,Goal,Path,FinalPath):- 
          connect(Node,Next),
          not(member(Next,Path)),
          route(Next,Goal,[Next|Path],FinalPath).

%%% Start:
     plan(Init,Goal,FinalPath):-
          route(Goal,Init,[Goal],FinalPath).                           
     
                                                  
%%% Find all plans from 's' to 'g'.
     fap(Plans) :- findall(Path, plan(s,g,Path),Plans), writelist(Plans).

writelist([]) :- !, nl.
writelist([H|T]) :- write(H),nl,writelist(T).

%%% Find all plans and assert; p(<plan>).
     fap-assert:- plan(s,g,Plan), assert(p(Plan)), fail.
     fap-assert.

%%% Count: zliczanie krotnosci wezla w planach.
     count(N,_):- p(P), member(N,P), add(N), fail.
     count(N,K):- q(N,K).

add(N):- \+ q(N,_),!, assert(q(N,1)).
add(N):- retract(q(N,K)), K1 is K+1, assert(q(N,K1)).

     countall:- nodes(LN), select(N,LN,_), count(N,K), write('node: '), write(N), write('  in: '), write(K),nl.
